﻿using System.Linq.Expressions;

namespace System.Data.Entity.Extensions.Repository
{
    /// <summary>
    /// 
    /// </summary>
    /// <typeparam name="TEntity"></typeparam>
    public class FilterEventArgs<TEntity> : EventArgs where TEntity : class
    {
        #region Constructor

        /// <summary>
        /// 
        /// </summary>
        /// <param name="entity"></param>
        /// <param name="result"></param>
        public FilterEventArgs(TEntity entity, bool result)
            : base()
        {
            this._entity = entity;
            this._result = result;
        }

        #endregion

        #region TEntity

        /// <summary>
        /// 
        /// </summary>
        private TEntity _entity;

        /// <summary>
        /// 
        /// </summary>
        public TEntity Entity
        {
            get
            {
                return this._entity;
            }
        }

        #endregion

        #region Result

        /// <summary>
        /// 
        /// </summary>
        private bool _result;

        /// <summary>
        /// 
        /// </summary>
        public bool Result
        {
            get
            {
                return this._result;
            }
            set
            {
                if (value != this._result)
                {
                    this._result = value;
                }
            }
        }

        #endregion
    }
}
